/**
 * Copyright 2011-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.maven.plugin.mergeproperties.core;

import java.util.List;

/**
 * This interface represents a filtering strategy service
 * @author Jeremy Cazaux
 */
public interface FilteringStrategy {

    /**
     * Execute the strategy
     * @param key
     * @param values
     * @param separator
     * @return the property
     */
    public String execute(String key, List<String> values, final String separator);

    /**
     * @param s
     * @return true if s match pattern; false otherwise.
     */
    public boolean matchPattern(final String s);

    /**
     * Initialize the pattern
     */
    public void initPattern();

}
